 <?PHP

/***********************************************************/
/* GALERIE DE PHOTOS - PROGRAMMEUR : Jean-Baptiste Vincent */
/*           version 2.2d (06/04/09)                       */
/*                                                         */
/*           Licence: GPL                                  */
/*                                                         */
/*           Check for new versions at :                   */
/*           http://galeriephp.free.fr                     */
/***********************************************************/

/* Fichier contenant la description du menu */
$menu_file = "./menu_liste.txt";

/* Rpertoire des miniatures */
$mini_dir="./miniatures/";

$width_thumbs=100;
$height_thumbs=75;

/*********************************************/
/* Cette fonction cre la structure          */
/* de la galerie (<div_menu> + <div_gallery> */
/*********************************************/

function build_gallery($menu_file)
{
   //code javascript pour l'affichage des sous-menus et de la galerie

print <<<END
   <script type="text/JavaScript">

   var lastId;

   function toggle(Id)
   {
      document.getElementById(lastId).style.display='none';
      
      if (document.getElementById(Id).style.display == 'none')
      {  document.getElementById(Id).style.display = 'inline';
         //$(document.getElementById(Id)).show("fast");
      }
      else
      {  document.getElementById(Id).style.display = 'none';
         //$(document.getElementById(Id)).hide("fast");
      }

      lastId=Id;
   }

   function updateDivPhotos(content)
   {
     if (document.getElementById)
     {  document.getElementById('div_photos').innerHTML = content;
     }
     else if (document.all)
     {  document.all['div_photos'].innerHTML = content;
     }
   }
   </script>
END;

   // Affichage du menu
   print "\n<div Id=\"div_menu\">\n";
   $default_content = display_menu($menu_file);
   print "</div>";

   // Affichage de la galerie
   print "<div Id=\"div_photos\">";
   if($default_content != "")
   {
     $default_content=str_replace("\'", "'", $default_content);
     $default_content=str_replace("/\/", "/", $default_content);
     $default_content=str_replace("\/", "/", $default_content);
     print "$default_content";
   }
   else
   {
     print "Slectionnez la galerie que vous voulez voir avec les liens  gauche.";
   }
   print "</div>\n";
}

/**********************************/
/* Cette fonction affiche le menu */
/**********************************/
function display_menu($menu_file)
{   $default_content = "";
    //lecture du fichier menu
    $list=file($menu_file);

    $menu_ouvert=false;
    $num_galerie=1;
    $num_ss_gal=0;

    //affichage des liens
    foreach ($list as $line)
    {   $nb=0;

        $line=trim($line, "\n\r");
        $line=explode(";",$line);

        if(isset($line[2])) //si le nom du fichier existe
        {   $line[2]=trim($line[2]); //on enlve les espaces

            $sub_file=file($line[2]); //on met le contenu du fichier dans un tableau
            if (is_array($sub_file)==true) //on vrifie que le tableau existe
            {  foreach($sub_file as $entry) //pour chaque entre du tableau
               {  $entry=explode(";",$entry); //on rcupre la premire partie
                  if(is_file($entry[0])or is_link($entry[0])) //si c'est une image on la compte
                  {  $nb=$nb+1;
                  }
                  else if(is_dir($entry[0])) //si c'est un rep on va voir combien d'images il contient
                  {  $rep = opendir($entry[0]);
                     while (false !== ($image = readdir($rep)))
                     {  if ($image != "." && $image != "..") $nb=$nb+1;
                     }
                     closedir($rep);
                  }
               }
            }
            $div_content = display_gallery_gd($line[2]);
            $num_ss_gal += 1;

            if(isset($line[3]) && trim($line[3])=="display")
            {
                $default_content = $div_content;
                print "<li><a href=\"#\" class=\"active\" Id=\"sg$num_ss_gal\" onClick=\"javascript:$('#div_menu li a').removeClass('active');$(this).addClass('active');updateDivPhotos('$div_content');\" title=\"$line[1]\">";
            }
            else
              print "<li><a href=\"#\" Id=\"sg$num_ss_gal\" onClick=\"javascript:$('#div_menu li a').removeClass('active');$(this).addClass('active');updateDivPhotos('$div_content');\" title=\"$line[1]\">";

            print "$line[0] ($nb photos)";
            print "</a></li>\n";
        }
        else
        {   if($menu_ouvert==true)
            {  print "</ul><br /><br />\n";
               $menu_ouvert=false;
            }
            print "<a href=\"#\" onClick=\"javascript:toggle('galerie_$num_galerie');\">$line[0]</a>";

            // afficher ou pas ?
            if(isset($line[1]))
            {
              $line[1]=trim($line[1]); //on enlve les espaces
              if($line[1]=="open")
              {  print "<ul Id=\"galerie_$num_galerie\" style=\"display:inline; \">\n";
                 print "<script type=\"text/JavaScript\">lastId='galerie_$num_galerie';</script>";
              }
              else
                print "<ul Id=\"galerie_$num_galerie\" style=\"display:none; \">\n";
            }
            else
              print "<ul Id=\"galerie_$num_galerie\"style=\"display:none; \">\n";

            $menu_ouvert=true;
            $num_galerie=$num_galerie+1;
        }
    }
    print "</ul>\n";
    return $default_content;
}

/************************************************************/
/* Cette fonction cre les MINIATURES des photos listes    */
/* dans un fichier $list_file prdfini par l'utilisateur   */
/* ATTENTION : POUR UTILISER CETTE FONTION, VOTRE SERVEUR   */
/*             DOIT AVOIR LA LIBRAIRIE GD INSTALLEE         */
/************************************************************/
function display_gallery_gd($list_file)
{   global $width_thumbs, $height_thumbs, $mini_dir;

    //on teste l'existence du rpertoire des miniatures
    if (!is_dir($mini_dir))
    {  mkdir($mini_dir);
    }

    if ($list_file=="")
    {   return "Cette galerie ne contient pas de photos.";
    }

    //lecture du fichier liste
    $list_file=trim($list_file, "'");
    $list=file($list_file);

    //affichage des miniatures
    $nb=0;
    $nb_dir=0;
    $div_content="";
    foreach ($list as $line)
    {   $line=trim($line, "\n\r");
        $line=explode(";",$line);

        //$line[0] est-il un fichier ou un rpertoire ?
        if(is_file($line[0]))
        {  //Si c'est un fichier :
           $nb=$nb+1;
           $image=explode("/",$line[0]);
           $temp=count($image)-1;
           $image=$image[$temp];
           $image_sans_ext=explode(".",$image);
           $image_mini=$mini_dir.$image_sans_ext[0]."_mini.jpg";

           if (!isset($line[1]))
           {  $commentaire="aucun commentaire associ  cette image";  }
           else
           {  $commentaire=$line[1];  }

           //si la miniature n'existe pas on la cre
           if (!is_file($image_mini))
           {  $im = ImageCreateTrueColor ($width_thumbs, $height_thumbs);

              $source = @ImageCreateFromJpeg($line[0])
                      or die ("bug");

              $largeurSource = imagesx($source);
              $hauteurSource = imagesy($source);

              ImageCopyResampled($im, $source, 0, 0, 0, 0, $width_thumbs, $height_thumbs, $largeurSource, $hauteurSource);

              ImageJpeg($im,$image_mini);
           }

           $div_content .= "<a href=\'$line[0]\' title=\'$commentaire\' rel=\'$list_file\' OnClick=\'javascript:tb_show(this.title, this.href, this.rel); return false;\'>";
           $div_content .= "<span class=\'img-shadow\'><img src=\'$image_mini\' alt=\'\' \/><\/span>";
           $div_content .= "<\/a>";
       }
       else if(is_dir($line[0]))
       {  //Si c'est un rpertoire :
          $div_content = "";
          $nb_dir=$nb_dir+1;
          $nom_dir=explode("/",$line[0]);
          $temp=count($nom_dir)-1;
          $nom_dir=$nom_dir[$temp]."_mini/";
          $rep = opendir($line[0]);
          
          //Classement par ordre alphabtique
          $i=0;
          while (false !== ($image = readdir($rep))) 
          {
            $sorted_rep[$i] = $image;
            $i++;
          }
          sort($sorted_rep, SORT_STRING);

          foreach ($sorted_rep as $image)
          {  if ($image != "." && $image != "..")
             {  $nb=$nb+1;
                $image_sans_ext=explode(".",$image);
                $image_mini=$mini_dir.$nom_dir.$image_sans_ext[0]."_mini.jpg";

                $image_url="$line[0]/$image";

                if (!is_file($image_mini))
                {  $im = ImageCreateTrueColor ($width_thumbs, $height_thumbs);

                   $source = @ImageCreateFromJpeg($image_url)
                           or die ("");

                   $largeurSource = imagesx($source);
                   $hauteurSource = imagesy($source);

                   ImageCopyResampled($im, $source, 0, 0, 0, 0, $width_thumbs, $height_thumbs, $largeurSource, $hauteurSource);

                   //On vrifie que le rpertoire des miniatures existe bien
                   if (!is_dir($mini_dir.$nom_dir))
                   { mkdir($mini_dir.$nom_dir); }

                   $err_msg="Vous devez crer un dossier<br><b>$nom_dir</b><br>dans le rpertoire <b>$mini_dir</b>";

                   @ImageJpeg($im,$image_mini) or die("$err_msg");
                }
                   $commentaire="aucun commentaire associ  cette image";

                   $div_content .= "<a href=\'$image_url\' title=\'$commentaire\' rel=\'$list_file\' OnClick=\'javascript:tb_show(this.title, this.href, this.rel); return false;\'>";
                   $div_content .= "<span class=\'img-shadow\'><img src=\'$image_mini\' alt=\'\' /\/><\/span>";
                   $div_content .= "<\/a>";
             }
          }
          closedir($rep);
       }
   }
   return $div_content;
}

/**************************/
/* Construction de la page*/
/**************************/

build_gallery($menu_file);

?>